/*	Sample program for Olimex AVR-P28 with ATMega8 processor
 *	Toggles the Led On when the button is pressed
 *	Compile with AVRStudio+WinAVR (gcc version 3.4.6)
 */

#define	__AVR_ATmega8__	1

#include "avr/io.h"

void Initialize(void)
{
	PORTB = 0x0;
	PORTC = 1<<5;	/* turn the LED off */
	PORTD = 0x0;

	DDRB = 0x0;
	DDRC = 1<<5;	/* PC5 as output - the LED is there */
	DDRD = 0x0;

	// External Interrupt(s) initialization
	// INT0: Off
	// INT1: Off
	GIMSK=0x00;
	MCUCR=0x00;
	
}

/*	state = 0 -> Led Off
 *	state = 1 -> Led On
 *	state !=[0,1] -> Led Toggle 
 */
void LedSet(unsigned char state)
{
	switch (state)
	{
		case 0:
			PORTC &= ~(1<<5);
			break;
		case 1:
			PORTC |= 1<<5;
			break;
		default:
			if (PORTC & 1<<5)
				PORTC &= ~(1<<5);
			else
				PORTC |= 1<<5;
	}
	
}


int main(void)
{
	int i;

	Initialize();

	while (1)
	{
		if (!(PIND & 1<<2))	/* PIND2 is LOW when the button is pressed*/
		{
			LedSet(0);
			for (i=65535;i;i--);
			{
			__asm__ __volatile__ ("nop");
			__asm__ __volatile__ ("nop");
			__asm__ __volatile__ ("nop");
			__asm__ __volatile__ ("nop");
			}
			LedSet(1);
		}
	}
	return 0;
}
